"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var AuthorizeCacheSecurityGroupIngress_1 = require("../model/operations/AuthorizeCacheSecurityGroupIngress");
var AuthorizeCacheSecurityGroupIngressCommand = /** @class */ (function () {
    function AuthorizeCacheSecurityGroupIngressCommand(input) {
        this.input = input;
        this.model = AuthorizeCacheSecurityGroupIngress_1.AuthorizeCacheSecurityGroupIngress;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    AuthorizeCacheSecurityGroupIngressCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return AuthorizeCacheSecurityGroupIngressCommand;
}());
exports.AuthorizeCacheSecurityGroupIngressCommand = AuthorizeCacheSecurityGroupIngressCommand;
//# sourceMappingURL=AuthorizeCacheSecurityGroupIngressCommand.js.map