"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DeleteCacheSecurityGroup_1 = require("../model/operations/DeleteCacheSecurityGroup");
var DeleteCacheSecurityGroupCommand = /** @class */ (function () {
    function DeleteCacheSecurityGroupCommand(input) {
        this.input = input;
        this.model = DeleteCacheSecurityGroup_1.DeleteCacheSecurityGroup;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DeleteCacheSecurityGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DeleteCacheSecurityGroupCommand;
}());
exports.DeleteCacheSecurityGroupCommand = DeleteCacheSecurityGroupCommand;
//# sourceMappingURL=DeleteCacheSecurityGroupCommand.js.map