"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var RebootCacheCluster_1 = require("../model/operations/RebootCacheCluster");
var RebootCacheClusterCommand = /** @class */ (function () {
    function RebootCacheClusterCommand(input) {
        this.input = input;
        this.model = RebootCacheCluster_1.RebootCacheCluster;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    RebootCacheClusterCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return RebootCacheClusterCommand;
}());
exports.RebootCacheClusterCommand = RebootCacheClusterCommand;
//# sourceMappingURL=RebootCacheClusterCommand.js.map