"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateCacheClusterInput_1 = require("../shapes/CreateCacheClusterInput");
var CreateCacheClusterOutput_1 = require("../shapes/CreateCacheClusterOutput");
var ReplicationGroupNotFoundFault_1 = require("../shapes/ReplicationGroupNotFoundFault");
var InvalidReplicationGroupStateFault_1 = require("../shapes/InvalidReplicationGroupStateFault");
var CacheClusterAlreadyExistsFault_1 = require("../shapes/CacheClusterAlreadyExistsFault");
var InsufficientCacheClusterCapacityFault_1 = require("../shapes/InsufficientCacheClusterCapacityFault");
var CacheSecurityGroupNotFoundFault_1 = require("../shapes/CacheSecurityGroupNotFoundFault");
var CacheSubnetGroupNotFoundFault_1 = require("../shapes/CacheSubnetGroupNotFoundFault");
var ClusterQuotaForCustomerExceededFault_1 = require("../shapes/ClusterQuotaForCustomerExceededFault");
var NodeQuotaForClusterExceededFault_1 = require("../shapes/NodeQuotaForClusterExceededFault");
var NodeQuotaForCustomerExceededFault_1 = require("../shapes/NodeQuotaForCustomerExceededFault");
var CacheParameterGroupNotFoundFault_1 = require("../shapes/CacheParameterGroupNotFoundFault");
var InvalidVPCNetworkStateFault_1 = require("../shapes/InvalidVPCNetworkStateFault");
var TagQuotaPerResourceExceeded_1 = require("../shapes/TagQuotaPerResourceExceeded");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateCacheCluster = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateCacheCluster",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateCacheClusterInput_1.CreateCacheClusterInput
    },
    output: {
        shape: CreateCacheClusterOutput_1.CreateCacheClusterOutput,
        resultWrapper: "CreateCacheClusterResult"
    },
    errors: [
        {
            shape: ReplicationGroupNotFoundFault_1.ReplicationGroupNotFoundFault
        },
        {
            shape: InvalidReplicationGroupStateFault_1.InvalidReplicationGroupStateFault
        },
        {
            shape: CacheClusterAlreadyExistsFault_1.CacheClusterAlreadyExistsFault
        },
        {
            shape: InsufficientCacheClusterCapacityFault_1.InsufficientCacheClusterCapacityFault
        },
        {
            shape: CacheSecurityGroupNotFoundFault_1.CacheSecurityGroupNotFoundFault
        },
        {
            shape: CacheSubnetGroupNotFoundFault_1.CacheSubnetGroupNotFoundFault
        },
        {
            shape: ClusterQuotaForCustomerExceededFault_1.ClusterQuotaForCustomerExceededFault
        },
        {
            shape: NodeQuotaForClusterExceededFault_1.NodeQuotaForClusterExceededFault
        },
        {
            shape: NodeQuotaForCustomerExceededFault_1.NodeQuotaForCustomerExceededFault
        },
        {
            shape: CacheParameterGroupNotFoundFault_1.CacheParameterGroupNotFoundFault
        },
        {
            shape: InvalidVPCNetworkStateFault_1.InvalidVPCNetworkStateFault
        },
        {
            shape: TagQuotaPerResourceExceeded_1.TagQuotaPerResourceExceeded
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=CreateCacheCluster.js.map