"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DescribeCacheClustersInput_1 = require("../shapes/DescribeCacheClustersInput");
var DescribeCacheClustersOutput_1 = require("../shapes/DescribeCacheClustersOutput");
var CacheClusterNotFoundFault_1 = require("../shapes/CacheClusterNotFoundFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.DescribeCacheClusters = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "DescribeCacheClusters",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: DescribeCacheClustersInput_1.DescribeCacheClustersInput
    },
    output: {
        shape: DescribeCacheClustersOutput_1.DescribeCacheClustersOutput,
        resultWrapper: "DescribeCacheClustersResult"
    },
    errors: [
        {
            shape: CacheClusterNotFoundFault_1.CacheClusterNotFoundFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=DescribeCacheClusters.js.map