"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DescribeCacheParametersInput_1 = require("../shapes/DescribeCacheParametersInput");
var DescribeCacheParametersOutput_1 = require("../shapes/DescribeCacheParametersOutput");
var CacheParameterGroupNotFoundFault_1 = require("../shapes/CacheParameterGroupNotFoundFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.DescribeCacheParameters = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "DescribeCacheParameters",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: DescribeCacheParametersInput_1.DescribeCacheParametersInput
    },
    output: {
        shape: DescribeCacheParametersOutput_1.DescribeCacheParametersOutput,
        resultWrapper: "DescribeCacheParametersResult"
    },
    errors: [
        {
            shape: CacheParameterGroupNotFoundFault_1.CacheParameterGroupNotFoundFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=DescribeCacheParameters.js.map