"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DescribeSnapshotsInput_1 = require("../shapes/DescribeSnapshotsInput");
var DescribeSnapshotsOutput_1 = require("../shapes/DescribeSnapshotsOutput");
var CacheClusterNotFoundFault_1 = require("../shapes/CacheClusterNotFoundFault");
var SnapshotNotFoundFault_1 = require("../shapes/SnapshotNotFoundFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.DescribeSnapshots = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "DescribeSnapshots",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: DescribeSnapshotsInput_1.DescribeSnapshotsInput
    },
    output: {
        shape: DescribeSnapshotsOutput_1.DescribeSnapshotsOutput,
        resultWrapper: "DescribeSnapshotsResult"
    },
    errors: [
        {
            shape: CacheClusterNotFoundFault_1.CacheClusterNotFoundFault
        },
        {
            shape: SnapshotNotFoundFault_1.SnapshotNotFoundFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=DescribeSnapshots.js.map