"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ModifyCacheParameterGroupInput_1 = require("../shapes/ModifyCacheParameterGroupInput");
var ModifyCacheParameterGroupOutput_1 = require("../shapes/ModifyCacheParameterGroupOutput");
var CacheParameterGroupNotFoundFault_1 = require("../shapes/CacheParameterGroupNotFoundFault");
var InvalidCacheParameterGroupStateFault_1 = require("../shapes/InvalidCacheParameterGroupStateFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.ModifyCacheParameterGroup = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "ModifyCacheParameterGroup",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: ModifyCacheParameterGroupInput_1.ModifyCacheParameterGroupInput
    },
    output: {
        shape: ModifyCacheParameterGroupOutput_1.ModifyCacheParameterGroupOutput,
        resultWrapper: "ModifyCacheParameterGroupResult"
    },
    errors: [
        {
            shape: CacheParameterGroupNotFoundFault_1.CacheParameterGroupNotFoundFault
        },
        {
            shape: InvalidCacheParameterGroupStateFault_1.InvalidCacheParameterGroupStateFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=ModifyCacheParameterGroup.js.map