"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ResetCacheParameterGroupInput_1 = require("../shapes/ResetCacheParameterGroupInput");
var ResetCacheParameterGroupOutput_1 = require("../shapes/ResetCacheParameterGroupOutput");
var InvalidCacheParameterGroupStateFault_1 = require("../shapes/InvalidCacheParameterGroupStateFault");
var CacheParameterGroupNotFoundFault_1 = require("../shapes/CacheParameterGroupNotFoundFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.ResetCacheParameterGroup = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "ResetCacheParameterGroup",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: ResetCacheParameterGroupInput_1.ResetCacheParameterGroupInput
    },
    output: {
        shape: ResetCacheParameterGroupOutput_1.ResetCacheParameterGroupOutput,
        resultWrapper: "ResetCacheParameterGroupResult"
    },
    errors: [
        {
            shape: InvalidCacheParameterGroupStateFault_1.InvalidCacheParameterGroupStateFault
        },
        {
            shape: CacheParameterGroupNotFoundFault_1.CacheParameterGroupNotFoundFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=ResetCacheParameterGroup.js.map