"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RevokeCacheSecurityGroupIngressInput_1 = require("../shapes/RevokeCacheSecurityGroupIngressInput");
var RevokeCacheSecurityGroupIngressOutput_1 = require("../shapes/RevokeCacheSecurityGroupIngressOutput");
var CacheSecurityGroupNotFoundFault_1 = require("../shapes/CacheSecurityGroupNotFoundFault");
var AuthorizationNotFoundFault_1 = require("../shapes/AuthorizationNotFoundFault");
var InvalidCacheSecurityGroupStateFault_1 = require("../shapes/InvalidCacheSecurityGroupStateFault");
var InvalidParameterValueException_1 = require("../shapes/InvalidParameterValueException");
var InvalidParameterCombinationException_1 = require("../shapes/InvalidParameterCombinationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.RevokeCacheSecurityGroupIngress = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "RevokeCacheSecurityGroupIngress",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: RevokeCacheSecurityGroupIngressInput_1.RevokeCacheSecurityGroupIngressInput
    },
    output: {
        shape: RevokeCacheSecurityGroupIngressOutput_1.RevokeCacheSecurityGroupIngressOutput,
        resultWrapper: "RevokeCacheSecurityGroupIngressResult"
    },
    errors: [
        {
            shape: CacheSecurityGroupNotFoundFault_1.CacheSecurityGroupNotFoundFault
        },
        {
            shape: AuthorizationNotFoundFault_1.AuthorizationNotFoundFault
        },
        {
            shape: InvalidCacheSecurityGroupStateFault_1.InvalidCacheSecurityGroupStateFault
        },
        {
            shape: InvalidParameterValueException_1.InvalidParameterValueException
        },
        {
            shape: InvalidParameterCombinationException_1.InvalidParameterCombinationException
        }
    ]
};
//# sourceMappingURL=RevokeCacheSecurityGroupIngress.js.map