"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _Endpoint_1 = require("./_Endpoint");
var _PendingModifiedValues_1 = require("./_PendingModifiedValues");
var _NotificationConfiguration_1 = require("./_NotificationConfiguration");
var _CacheSecurityGroupMembershipList_1 = require("./_CacheSecurityGroupMembershipList");
var _CacheParameterGroupStatus_1 = require("./_CacheParameterGroupStatus");
var _CacheNodeList_1 = require("./_CacheNodeList");
var _SecurityGroupMembershipList_1 = require("./_SecurityGroupMembershipList");
exports._CacheCluster = {
    type: "structure",
    required: [],
    members: {
        CacheClusterId: {
            shape: {
                type: "string"
            }
        },
        ConfigurationEndpoint: {
            shape: _Endpoint_1._Endpoint
        },
        ClientDownloadLandingPage: {
            shape: {
                type: "string"
            }
        },
        CacheNodeType: {
            shape: {
                type: "string"
            }
        },
        Engine: {
            shape: {
                type: "string"
            }
        },
        EngineVersion: {
            shape: {
                type: "string"
            }
        },
        CacheClusterStatus: {
            shape: {
                type: "string"
            }
        },
        NumCacheNodes: {
            shape: {
                type: "integer"
            }
        },
        PreferredAvailabilityZone: {
            shape: {
                type: "string"
            }
        },
        CacheClusterCreateTime: {
            shape: {
                type: "timestamp"
            }
        },
        PreferredMaintenanceWindow: {
            shape: {
                type: "string"
            }
        },
        PendingModifiedValues: {
            shape: _PendingModifiedValues_1._PendingModifiedValues
        },
        NotificationConfiguration: {
            shape: _NotificationConfiguration_1._NotificationConfiguration
        },
        CacheSecurityGroups: {
            shape: _CacheSecurityGroupMembershipList_1._CacheSecurityGroupMembershipList
        },
        CacheParameterGroup: {
            shape: _CacheParameterGroupStatus_1._CacheParameterGroupStatus
        },
        CacheSubnetGroupName: {
            shape: {
                type: "string"
            }
        },
        CacheNodes: {
            shape: _CacheNodeList_1._CacheNodeList
        },
        AutoMinorVersionUpgrade: {
            shape: {
                type: "boolean"
            }
        },
        SecurityGroups: {
            shape: _SecurityGroupMembershipList_1._SecurityGroupMembershipList
        },
        ReplicationGroupId: {
            shape: {
                type: "string"
            }
        },
        SnapshotRetentionLimit: {
            shape: {
                type: "integer"
            }
        },
        SnapshotWindow: {
            shape: {
                type: "string"
            }
        },
        AuthTokenEnabled: {
            shape: {
                type: "boolean"
            }
        },
        TransitEncryptionEnabled: {
            shape: {
                type: "boolean"
            }
        },
        AtRestEncryptionEnabled: {
            shape: {
                type: "boolean"
            }
        }
    }
};
//# sourceMappingURL=_CacheCluster.js.map